
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit2.Objects.InstallMissingMediaPluginsPermissionRequest
    ( 

-- * Exported types
    InstallMissingMediaPluginsPermissionRequest(..),
    InstallMissingMediaPluginsPermissionRequestK,
    toInstallMissingMediaPluginsPermissionRequest,
    noInstallMissingMediaPluginsPermissionRequest,


 -- * Methods
-- ** installMissingMediaPluginsPermissionRequestGetDescription
    installMissingMediaPluginsPermissionRequestGetDescription,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit2.Types
import GI.WebKit2.Callbacks
import qualified GI.GObject as GObject

newtype InstallMissingMediaPluginsPermissionRequest = InstallMissingMediaPluginsPermissionRequest (ForeignPtr InstallMissingMediaPluginsPermissionRequest)
foreign import ccall "webkit_install_missing_media_plugins_permission_request_get_type"
    c_webkit_install_missing_media_plugins_permission_request_get_type :: IO GType

type instance ParentTypes InstallMissingMediaPluginsPermissionRequest = InstallMissingMediaPluginsPermissionRequestParentTypes
type InstallMissingMediaPluginsPermissionRequestParentTypes = '[GObject.Object, PermissionRequest]

instance GObject InstallMissingMediaPluginsPermissionRequest where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_install_missing_media_plugins_permission_request_get_type
    

class GObject o => InstallMissingMediaPluginsPermissionRequestK o
instance (GObject o, IsDescendantOf InstallMissingMediaPluginsPermissionRequest o) => InstallMissingMediaPluginsPermissionRequestK o

toInstallMissingMediaPluginsPermissionRequest :: InstallMissingMediaPluginsPermissionRequestK o => o -> IO InstallMissingMediaPluginsPermissionRequest
toInstallMissingMediaPluginsPermissionRequest = unsafeCastTo InstallMissingMediaPluginsPermissionRequest

noInstallMissingMediaPluginsPermissionRequest :: Maybe InstallMissingMediaPluginsPermissionRequest
noInstallMissingMediaPluginsPermissionRequest = Nothing

type instance AttributeList InstallMissingMediaPluginsPermissionRequest = InstallMissingMediaPluginsPermissionRequestAttributeList
type InstallMissingMediaPluginsPermissionRequestAttributeList = ('[ ] :: [(Symbol, *)])

type instance SignalList InstallMissingMediaPluginsPermissionRequest = InstallMissingMediaPluginsPermissionRequestSignalList
type InstallMissingMediaPluginsPermissionRequestSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method InstallMissingMediaPluginsPermissionRequest::get_description
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2" "InstallMissingMediaPluginsPermissionRequest", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2" "InstallMissingMediaPluginsPermissionRequest", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_install_missing_media_plugins_permission_request_get_description" webkit_install_missing_media_plugins_permission_request_get_description :: 
    Ptr InstallMissingMediaPluginsPermissionRequest -> -- _obj : TInterface "WebKit2" "InstallMissingMediaPluginsPermissionRequest"
    IO CString


installMissingMediaPluginsPermissionRequestGetDescription ::
    (MonadIO m, InstallMissingMediaPluginsPermissionRequestK a) =>
    a ->                                    -- _obj
    m T.Text
installMissingMediaPluginsPermissionRequestGetDescription _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_install_missing_media_plugins_permission_request_get_description _obj'
    checkUnexpectedReturnNULL "webkit_install_missing_media_plugins_permission_request_get_description" result
    result' <- cstringToText result
    touchManagedPtr _obj
    return result'


