
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit2.Structs.ScriptDialog
    ( 

-- * Exported types
    ScriptDialog(..)                        ,
    noScriptDialog                          ,


 -- * Methods
-- ** scriptDialogConfirmSetConfirmed
    scriptDialogConfirmSetConfirmed         ,


-- ** scriptDialogGetDialogType
    scriptDialogGetDialogType               ,


-- ** scriptDialogGetMessage
    scriptDialogGetMessage                  ,


-- ** scriptDialogPromptGetDefaultText
    scriptDialogPromptGetDefaultText        ,


-- ** scriptDialogPromptSetText
    scriptDialogPromptSetText               ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit2.Types
import GI.WebKit2.Callbacks

newtype ScriptDialog = ScriptDialog (ForeignPtr ScriptDialog)
foreign import ccall "webkit_script_dialog_get_type" c_webkit_script_dialog_get_type :: 
    IO GType

instance BoxedObject ScriptDialog where
    boxedType _ = c_webkit_script_dialog_get_type

noScriptDialog :: Maybe ScriptDialog
noScriptDialog = Nothing

-- method ScriptDialog::confirm_set_confirmed
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2" "ScriptDialog", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "confirmed", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2" "ScriptDialog", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "confirmed", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_script_dialog_confirm_set_confirmed" webkit_script_dialog_confirm_set_confirmed :: 
    Ptr ScriptDialog ->                     -- _obj : TInterface "WebKit2" "ScriptDialog"
    CInt ->                                 -- confirmed : TBasicType TBoolean
    IO ()


scriptDialogConfirmSetConfirmed ::
    (MonadIO m) =>
    ScriptDialog ->                         -- _obj
    Bool ->                                 -- confirmed
    m ()
scriptDialogConfirmSetConfirmed _obj confirmed = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    let confirmed' = (fromIntegral . fromEnum) confirmed
    webkit_script_dialog_confirm_set_confirmed _obj' confirmed'
    touchManagedPtr _obj
    return ()

-- method ScriptDialog::get_dialog_type
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2" "ScriptDialog", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2" "ScriptDialog", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit2" "ScriptDialogType"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_script_dialog_get_dialog_type" webkit_script_dialog_get_dialog_type :: 
    Ptr ScriptDialog ->                     -- _obj : TInterface "WebKit2" "ScriptDialog"
    IO CUInt


scriptDialogGetDialogType ::
    (MonadIO m) =>
    ScriptDialog ->                         -- _obj
    m ScriptDialogType
scriptDialogGetDialogType _obj = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    result <- webkit_script_dialog_get_dialog_type _obj'
    let result' = (toEnum . fromIntegral) result
    touchManagedPtr _obj
    return result'

-- method ScriptDialog::get_message
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2" "ScriptDialog", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2" "ScriptDialog", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_script_dialog_get_message" webkit_script_dialog_get_message :: 
    Ptr ScriptDialog ->                     -- _obj : TInterface "WebKit2" "ScriptDialog"
    IO CString


scriptDialogGetMessage ::
    (MonadIO m) =>
    ScriptDialog ->                         -- _obj
    m T.Text
scriptDialogGetMessage _obj = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    result <- webkit_script_dialog_get_message _obj'
    checkUnexpectedReturnNULL "webkit_script_dialog_get_message" result
    result' <- cstringToText result
    touchManagedPtr _obj
    return result'

-- method ScriptDialog::prompt_get_default_text
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2" "ScriptDialog", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2" "ScriptDialog", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_script_dialog_prompt_get_default_text" webkit_script_dialog_prompt_get_default_text :: 
    Ptr ScriptDialog ->                     -- _obj : TInterface "WebKit2" "ScriptDialog"
    IO CString


scriptDialogPromptGetDefaultText ::
    (MonadIO m) =>
    ScriptDialog ->                         -- _obj
    m T.Text
scriptDialogPromptGetDefaultText _obj = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    result <- webkit_script_dialog_prompt_get_default_text _obj'
    checkUnexpectedReturnNULL "webkit_script_dialog_prompt_get_default_text" result
    result' <- cstringToText result
    touchManagedPtr _obj
    return result'

-- method ScriptDialog::prompt_set_text
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2" "ScriptDialog", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "text", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2" "ScriptDialog", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "text", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_script_dialog_prompt_set_text" webkit_script_dialog_prompt_set_text :: 
    Ptr ScriptDialog ->                     -- _obj : TInterface "WebKit2" "ScriptDialog"
    CString ->                              -- text : TBasicType TUTF8
    IO ()


scriptDialogPromptSetText ::
    (MonadIO m) =>
    ScriptDialog ->                         -- _obj
    T.Text ->                               -- text
    m ()
scriptDialogPromptSetText _obj text = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    text' <- textToCString text
    webkit_script_dialog_prompt_set_text _obj' text'
    touchManagedPtr _obj
    freeMem text'
    return ()


